#include "syscall.h"

static FILE filebuf[3] = {
	{0,0},
	{1,0},
	{0,0},
};

static int errno;
int* __errno(void) {return &errno;}

void perror(char *s)
{
	puts(s);
}

FILE *stderr = &filebuf[2];

FILE* fopen(const char *file,const char *mode)
{
	FILE *fp;
	int fd,rw,oflags;
	if (file==NULL || mode==NULL) return NULL;

	rw = (mode[1]=='+') || (mode[1] && mode[2] == '+');
	switch(mode[0]) {
	case 'a': oflags = O_CREAT | (rw ? O_RDWR : O_WRONLY); break;
	case 'r': oflags = (rw ? O_RDWR : O_RDONLY); break;
	case 'w': oflags = /*O_TRUNC |*/ O_CREAT | (rw ? O_RDWR : O_WRONLY); break;
	default : return NULL;
	}
	/* O_TEXT/O_BINARY not support */
	if ((fp=malloc(sizeof(FILE)))==NULL) return NULL;

	if ((fd = open(file,oflags))<0) {
		free(fp);
		return NULL;
	}
	if (mode[0]=='a') lseek(fd,0,SEEK_END);
	fp->fd = fd;
	fp->eof = 0;
	return fp;
}

size_t fread(void *buf,size_t s1,size_t s2,FILE *fp)
{
	int size = s1*s2;
	int rsize;
	rsize = read(fp->fd,buf,size);
	if (rsize<size) fp->eof = TRUE;
	return rsize;
}

size_t fwrite(const void *buf,size_t size,size_t size2,FILE *fp)
{
	return write(fp->fd,buf,size*size2);
}

void fclose(FILE *fp)
{
	close(fp->fd);
	free(fp);
}

long fseek(FILE *fp,long offset,int type)
{
	return lseek(fp->fd,offset,type)==-1?-1:0;
}

int fflush(FILE *fp)
{
	return 0;
}

int feof(FILE *fp)
{
	return fp->eof;
}

int ftell(FILE *fp)
{
	return lseek(fp->fd,SEEK_CUR,0);
}